SystemOrganization addCategory: #'Orange-AngularJS'!

ALComponentResource subclass: #ORAuthJSONResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-AngularJS'!

!ORAuthJSONResource commentStamp: 'chc 6/22/2015 14:51' prior: 0!
Catches a username and password sent as JSON by a compoment like ORAngularJS. !

!ORAuthJSONResource methodsFor: 'as yet unclassified' stamp: 'chc 7/6/2015 11:55'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	"[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component auth: true ]."
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	^ (ALResponse seeOther: url)
		setCookie: cookie;
		"date: DateAndTime now;
		keepAlive: 'timeout=10, max=20';"
		yourself! !

!ORAuthJSONResource methodsFor: 'as yet unclassified' stamp: 'chc 3/11/2015 14:17'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORAuthJSONResource methodsFor: 'as yet unclassified' stamp: 'chc 7/6/2015 11:56'!
handleGet: aRequest locator: aLocator
	| request result authstring |
self halt.
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!ORAuthJSONResource methodsFor: 'as yet unclassified' stamp: 'chc 7/9/2015 13:26'!
handlePost: aRequest locator: aLocator
	| request result |
	request := ALAuthenticationRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	result := request signal.
	^ (result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [self denied]! !
